
const char * dui_parser_get_current_filename(DuiParser *par);

#define PSYNTAX(x,args...)                             \
	USERERR ("%s Syntax Error: " x,                     \
	dui_parser_get_current_filename(par), ##args)


#define GENERIC_CHECKS                                      \
	if (!attrs)                                              \
	{                                                        \
		PSYNTAX ("%s must have attributes!", eltname);        \
		return;                                               \
	}

#define CASE_STRDUP(STR,MEMB)                        \
   if (!strcmp ((char *)attrs[i], STR)) {            \
      MEMB = g_strdup((char *)attrs[i+1]);           \
   } else

#define CASE(STR,MEMB)                               \
   if (!strcmp ((char *)attrs[i], STR)) {            \
      MEMB = (char *) attrs[i+1];                    \
   } else

#define CASE_UNKNOWN                                          \
   {                                                          \
      PSYNTAX ("unknown %s attribute %s", eltname, attrs[i]); \
   }

#define CHECK_NEST(fld,prnt)                                     \
	if (!(fld))                                                   \
	{                                                             \
		PSYNTAX ("%s can only occur within a " prnt "!", eltname); \
		return;                                                    \
	}

#define CHECK_NEST2(flda,fldb,prnta,prntb)           \
	if ((!par->flda) && (!par->fldb))                 \
	{                                                 \
		PSYNTAX ("%s can only occur within a " prnta   \
              " or " prntb "!", eltname);            \
		return;                                        \
	}

#define REQUIRE(var,what)                            \
	if (NULL == var)                                  \
	{                                                 \
		PSYNTAX ("%s must specify " what, eltname);    \
		return;                                        \
	}

#define REQUIRE2(vara,varb,what)                     \
   if ((NULL == vara) && (NULL == varb))             \
   {                                                 \
      PSYNTAX ("%s must specify " what, eltname);    \
      return;                                        \
   }

#define REQUIRE3(vara,varb,varc,what)                \
	if ((NULL == vara) && (NULL == varb) && (NULL == varc))   \
	{                                                 \
		PSYNTAX ("%s must specify " what, eltname);    \
		return;                                        \
	}

#define REQUIRE4(vara,varb,varc,vard,what)           \
	if ((NULL==vara) && (NULL==varb) && (NULL==varc) && (NULL==vard))   \
	{                                                 \
		PSYNTAX ("%s must specify " what, eltname);    \
		return;                                        \
	}

/* =================================================================== */
