/*
 * FILE:
 * fall-object.h
 *
 * FUNCTION:
 * Demonstrates a basic GObject, using the glib-gobject interface.
 * This file implements a basic GObject, which will be used to
 * demonstrate how to use gobjects with DWI.
 *
 * Unfortunately, this file mostly demonstrates how verbose
 * the glib-gobject infrastructure is.  There's a lot of 
 * boiler-plate in here, a lot of generic code.
 *
 * I strongly suggest that you use "gob" to automatically
 * create your gobjects.  See http://www.5z.com/jirka/gob.html
 * for details; alternately, 'apt-get install gob2'
 * For an example usage of gob with dwi, see the "bike-calc" directory.
 *
 * The "falling object" is a gobject that has two inputs and 
 * one output.  The output is computed "on the fly" based on 
 * the inputs.
 *
 * HISTORY:
 * Linas Vepstas <linas@linas.org> March 2004
 */

#ifndef FALLING_H
#define FALLING_H

#include <glib-object.h>

typedef struct FallingObject_s Falling;

/* standard gtk-like declarations */
#define FALL_TYPE (fall_get_type())
#define FALL(object) (G_TYPE_CHECK_INSTANCE_CAST ((object), FALL_TYPE, Falling))
#define IS_FALL(object) (G_TYPE_CHECK_INSTANCE_TYPE ((object), FALL_TYPE))

GType fall_get_type (void);

Falling * fall_new (void);

#endif /* FALLING_H */
