/********************************************************************\
 * parse-qmap.h -- Plugin for Dui Parser that handle QofMap markup. *
 * Copyright (C) 2004 Linas Vepstas <linas@linas.org>               *
 * http://dwi.sourceforge.net                                       *
 *                                                                  *
 * This library is free software; you can redistribute it and/or    *
 * modify it under the terms of the GNU Lesser General Public       *
 * License as published by the Free Software Foundation; either     *
 * version 2.1 of the License, or (at your option) any later version.
 *                                                                  *
 * This library is distributed in the hope that it will be useful,  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *
 * GNU Lesser General Public License for more details.              *
 *                                                                  *
 * You should have received a copy of the GNU Lesser General Public *
 * License along with this program; if not, contact:                *
 *                                                                  *
 * Free Software Foundation           Voice:  +1-617-542-5942       *
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652       *
 * Boston, MA  02111-1307,  USA       gnu@gnu.org                   *
\********************************************************************/
#ifndef QMAP_PARSER_H
#define QMAP_PARSER_H
/**
 * Basic QofMap XML parser plugin.
 */

#include "readfile.h"

/** The QofMap XML Parse context */
typedef struct QmapParseCtxt_s QmapParseCtxt;

/** Add a parsing context to the parser that is capable of 
 *  understanding the QofMap filed-mapping syntax.
 */
QmapParseCtxt * qmap_new (DuiParser *par);

/** XX todo: add a destroy-context routine */

/** Return a GList of QofMap structures that this parser parsed out. */
GList * qmap_get_maplist (QmapParseCtxt *ctx);


#endif /* QMAP_PARSER */
